# Evaluation artifact for the emper IO runtime

We use a lot of connections in our evaluation make sure yout SOMAXCONN value is big enough.
I used `sysctl -w net.core.somaxconn=10240` for my evaluation.

## prepare

Three git submodules are included for emper, the legacy emper IO system and for a
echoserver using the IO design of memcached.

Run `git submodule init --update` to clone and checkout all submodules.

## build

Requirements:

	* pthread
	* libevent
	* rust / cargo
	* golang

Simply run `make` to build all non-emper echo server implementations

All used emper variants will be build when running `eval.py`.

## evaluate

Run `./eval.py -l` to benchmark all included implementations on the localhost.

See `./eval.py -h` for available options.

Evaluation results will be generated in `csv/<eval-host>-<server-host>/<timestamp>`

A simple matplotlib plot can be shown by running `plot_results.py csv/<eval-host>-<server-host>/<timestamp>`

## Two host evaluation

Per default `eval.py` will start the servers per ssh on faui49big02 so
if you run `eval.py` on any other machine you have a two host setup.
