# Copyright 2021 Florian Fischer
"""Definitions of the available server implementations to evaluate"""

from .globalvars import ROOT_DIR, SERVER_SRC_DIR

GO_20_WORKER_ENV_CMD = 'env GOMAXPROCS=20'
TOKIO_20_WORKER_ENV_CMD = 'env TOKIO_WORKER_COUNT=20'

SERVER_CMDS = {
    'go': f'{SERVER_SRC_DIR}/go-echo-server/echo',
    'go-100us': f'{SERVER_SRC_DIR}/go-echo-server/echo -computation 100',
    'go-200us': f'{SERVER_SRC_DIR}/go-echo-server/echo -computation 200',
    'go-20': f'{GO_20_WORKER_ENV_CMD} {SERVER_SRC_DIR}/go-echo-server/echo',
    'go-20-100us':
    f'{GO_20_WORKER_ENV_CMD} {SERVER_SRC_DIR}/go-echo-server/echo -computation 100',
    'go-20-200us':
    f'{GO_20_WORKER_ENV_CMD} {SERVER_SRC_DIR}/go-echo-server/echo -computation 200',
    'tokio': f'{SERVER_SRC_DIR}/tokio-echo/target/release/tokio-echo',
    'tokio-100us':
    f'{SERVER_SRC_DIR}/tokio-echo/target/release/tokio-echo 100',
    'tokio-200us':
    f'{SERVER_SRC_DIR}/tokio-echo/target/release/tokio-echo 200',
    'tokio-20':
    f'{TOKIO_20_WORKER_ENV_CMD} {SERVER_SRC_DIR}/tokio-echo/target/release/tokio-echo',
    'tokio-20-100us':
    f'{TOKIO_20_WORKER_ENV_CMD} {SERVER_SRC_DIR}/tokio-echo/target/release/tokio-echo 100',
    'tokio-20-200us':
    f'{TOKIO_20_WORKER_ENV_CMD} {SERVER_SRC_DIR}/tokio-echo/target/release/tokio-echo 200',

    #'libevent-single': f'{SERVER_SRC_DIR}/libevent-single/echoserver',
    'libevent-memcached': f'{SERVER_SRC_DIR}/libevent-echo/echoserver',
    #'libevent-cemer': f'{SERVER_SRC_DIR}/libevent-cemer-thread/echoserver_threaded',
    #'naive-singlethreaded': f'{SERVER_SRC_DIR}/naive-singlethreaded/echoserver',
    'naive-multithreaded': f'{SERVER_SRC_DIR}/naive-multithreaded/echoserver',
    'emper': f'{ROOT_DIR}/emper-{{flavor}}/build/apps/echoserver 12345',
    'burak':
    f'{SERVER_SRC_DIR}/burak/build-release/src/emper-echo-server 12345'
}
